unit gauge;
interface

type aGauge=object Row,LeftCol,Col: byte;
              ProcessedSoFar,progress,JobSize,minInc: longint;
              procedure assign(fn: string);
              procedure rewrite(r,c: byte; prompt: string);
              procedure update;
              procedure add(n: longint);
              procedure setPos(n: longint);
              procedure close;
       end;
implementation uses crt;
procedure aGauge.assign(fn: string);
var f: file of byte;
begin system.assign(f,fn); system.reset(f);
      JobSize:=fileSize(f);
      system.close(f);
end;
procedure aGauge.rewrite(r,c: byte; prompt: string);
var i: byte;
begin
      minInc:=trunc(JobSize/50);
      if minInc=0 then minInc:=1;
      LeftCol:=c; Row:=r;
      if Row>23 then Row:=23;
      gotoxy(leftCol,row);  write(prompt); clrEol;
      gotoxy(leftCol,row+1); for i:=1 to 50 do write(#176); clrEol;
      gotoxy(leftCol,row+2);
      write('0%..........25%.........50%.........75%........100%');
      clrEol;
      Col:=0;
      ProcessedSoFar:=0; progress:=0;
      inc(row);
      gotoxy(leftCol,row);
end;

procedure aGauge.Update;
var NewCol,c: byte;
begin
      NewCol:=trunc(ProcessedSoFar/JobSize*50);
      if NewCol>Col then
      begin gotoxy(LeftCol+Col,Row);
            for c:=Col to NewCol do write(#219);
            gotoxy(c,Row);
            Col:=NewCol
      end;
end;

procedure aGauge.setPos(n: longint);
begin progress:=n-ProcessedSoFar;
      if progress>=mininc then
      begin ProcessedSoFar:=n; progress:=0; update
      end;
end;

procedure aGauge.add(n: longint);
begin inc(progress,n);
      if progress>=mininc then
      begin inc(ProcessedSoFar,progress);
            progress:=0;
            update
      end;
end;
procedure aGauge.close;
begin gotoxy(1,row+2); writeln;
end;

end.
